; getdrive for wined
; this gets the drive number, opens the special file
; it returns ok, or does not return
;
; v. 1.09	2003 may 08 13:26:24
;
;  w. lenerz 1994  - 2018


	section get_drv

	xdef	get_drv
	xdef	do_drive		; used in button (wined_itact)

	xref	colw
	xref	do_list 	; does the 'list' menu extension
	xref	which_drv
	xref	act_esc
	xref	wins		; win drives list
	xref	do_fsel 	; does fsel menu extension (lib_menus_fsel)
	xref	do_itsl 	; does itsl menu extension (lib_menus_fsel)
	xref	which_file	; what file to edit text (wined_english)
	xref	badpar_error
	xref	read_error
	xref	read_sec	; reads a sector (wined_gu)
	xref	choice
	xref	wtprompt
	xref	which_type
	xref	nbr_sects
	xref	block		; text
	xref	warning 	; print err message (wined_filerr)
	xref	rdrwinfo	; redrws info windows (wined_rdrwinfo)
	xref	windrive
	xref	flop
	xref	set_drive
	xref	deftrak 	; (wined_cfg)
	xref	defside 	; (wined_cfg)
	xref	doselect	;    "    "
	xref	act_opts2	; (wined_options)
	xref	wintype 	; in wined_cfg
	xref	flp_parms	; sets flp paramaters (wined_options)
	xref	set_blocks	; set max nbr of blocks (wined_gu)

	include dev1_asm_wined_includes

; this gets the drive number, opens the special file
; it returns ok, or does not return

myregs	reg	d1-d4/a0-a2

get_drv movem.l myregs,-(a7)
	move.w	type(a4),d2
	tst.w	nsel(a4)
	bne.s	go_on
	move.l	file_id(a4),d0
	beq.s	startreq
	move.l	d0,a0
	moveq	#2,d0
	trap	#2		; close old file
startreq
	moveq	#0,d1		; max nbrs lines/cols
	move.l	#winpos,d2
	lea	colw,a1
	moveq	#0,d3
	move.b	(a1),d3
	lea	which_type,a0	; title
	lea	wtprompt,a1	; prompt
	lea	choice,a2	; the three options
	jsr	do_itsl 	; select one of them in d2)
	tst.l	d0		; ok ?
	bne	act_esc 	 ; no
ok	tst.w	d2		; must be 1 - 3
	beq	act_esc 	 ; quit if esc
	move.l	#0,partit(a4)	; there is no longer any offset

go_on	move.w	d2,type(a4)	; keep our type now
	subq.w	#1,d2		; is it win?
	bne	floppy_edit	; no->...

win_edit
	lea	windrive,a0	; 'title'
	bsr	getdrvnbr2	; get the drive number
	bne	act_esc 	 ; if problems
do_drive2
	moveq #-$01,d1
	moveq	#0,d3
	moveq	#1,d0
	lea	specfile(a4),a0
	trap	#2		; open special file
	tst.l	d0		; ok?
	beq.s	open_ok
op_err	bsr	read_error
	bra.s	win_edit
open_ok move.l	#0,sector(a4)
	move.l	#0,endsek(a4)
	move.w	#512,seclen(a4)
	move.l	#1,step(a4)
	
opcom	move.l	a0,file_id(a4)	; file opened ok
	move.w	d0,row(a4)
	moveq	#0,d0
	bsr	read_sec	; try to read a sector from it
	beq.s	read_ok 	; if error: show it ->...
	move.l	d0,-(a7)
	move.l	file_id(a4),a0
	moveq	#2,d0
	trap	#2		; close file
	move.l	(a7)+,d0
	bra.s	op_err
read_ok lea	wintype,a1
	tst.b	(a1)		; is it qubide ?
	beq.s	is_mir		; no->...
	lea	file_sp(a4),a1	; point to sector read
	move.w	d0,side(a4)	; head 0
	move.w	d0,track(a4)	; track 0
	move.w	d0,fl_sect(a4)	; sector 0
	move.w	n_tracks(a1),d0
	subq.w	#1,d0
	move.w	d0,maxtrack(a4) ; max number of tracks
	moveq	#0,d0
	move.b	num_heads(a1),d0
	subq.w	#1,d0
	move.w	d0,maxsides(a4) ; max number of heads
	move.w	sec_trk(a1),d0
	subq.w	#1,d0
	move.w	d0,maxsect(a4)	; max number of sectors
	bra.s	op_out
is_mir	lea	file_sp(a4),a1	; point to sector read
	move.l	(a1),d0
	move.b	#'A',d0
	cmp.l	#'QLWA',d0	; is it ql partition?
	beq.s	is_ql		; ... yes
	move.l	#$ffffff,endsek(a4) ; simulate last sector number for gem
	bra.s	op_out
is_ql	move.w	$2a(a1),d0	; number of total blocks
	move.w	$22(a1),d1	; number of sectors/block
	mulu	d1,d0		; total number of sectors
	subq.l	#1,d0
	move.l	d0,endsek(a4)	; holds last sector possible

op_out	move.w	#0,row(a4)	; always show first block
	jsr	set_blocks
	movem.l (a7)+,myregs
	rts

; this is called when button woken: tries to open file
do_drive
	movem.l myregs,-(a7)
	bsr	rdrwinfo	; redraw info windows
	move.w	type(a4),d0	; type of file to edit
	cmp.w	#flodisk,d0	; is it floppy?
	beq.s	dd2		; yes ->...
	cmp.w	#winedit,d0	; is it win ?
	beq	do_drive2	; yes ->...
	lea	fname_sp(a4),a0 ; no, so it must be file
	bra	opfile

floppy_edit
	subq.w	#1,d2		; is it floppy?
	bne	file_edit	; no->...
	lea	flop,a0
flp2	bsr.s	getdrvnbr
	lea	doselect,a0	; do we change floppy characteristics?
	tst.b	(a0)
	beq.s	dd2		; no
	bsr	act_opts2

dd2	moveq	#-$01,d1
	moveq	#0,d3
	moveq	#1,d0
	lea	specfile(a4),a0
	trap	#2		; open special file
	tst.l	d0		; ok?
	beq.s	open_ok2		; yes->...
op_err2 bsr	read_error
	bra.s	flp2
open_ok2
	jsr	flp_parms	; set flp_parameters
	move.l	#1,sector(a4)
	move.l	#1,endsek(a4)	;
	move.w	#1,fl_sect(a4)
	move.l	a0,file_id(a4)	; file opened ok
	move.w	#0,row(a4)
	bsr	read_sec	; try to read a sector from it
	beq	op_out		; if error: show it ->...
	move.l	d0,-(a7)
	move.l	file_id(a4),a0
	moveq	#2,d0
	trap	#2		; close file
	move.l	(a7)+,d0
	bra.s	op_err2

getdrvnbr2
	move.w	#0,fl_sect(a4)
	bra.s	getdcomm
getdrvnbr
	move.w	#1,fl_sect(a4)	; set this now - first sector...
getdcomm
	bsr	rdrwinfo
	move.w	nsel(a4),d1
	clr.w	nsel(a4)
	tst.w	d1
	bne.s	do_old
	move.l	#$00010008,d1	; max nbrs lines/cols
	move.l	#winpos,d2
;	 lea	 colwa,a1
;	 moveq	 #0,d3
;	 move.b  (a1),d3
	lea	colw,a1
	move.b	(a1),d3 	; colour way
	swap	d3
	move.b	(a1),d3 	; colour way
	moveq	#17,d4		; set bits 0 and 4
	lea	wins,a1
	sub.l	a2,a2
	jsr	do_list 	; which drive to use?
	tst.l	d0
	bne.s	gtdout
	move.w	(a1),d1 	; choice
	bge.s	got_drive	; ok->...
	cmp.w	#-1,d1
	beq.s	fromstart	; if esc: start again
	bra.s	do_old		; if ok, do the default one
got_drive
	addq.w	#1,d1
	move.w	d1,drive(a4)
do_old	bsr	set_drive
	moveq	#0,d0
gtdout	rts
fromstart
	addq.l	#4,a7
	bra	startreq	; if esc: start again
	rts

file_edit
	subq.w	#1,d2		; is it file edit?
	bne	act_esc 	 ; no, give up
do_file moveq	#0,d1		; max nbrs lines/cols
	moveq	#0,d0
	moveq	#0,d3
	lea	colw,a1
	move.b	(a1),d3 	; colourway
	swap	d3
	move.b	(a1),d3 	; colourway
	moveq	#0,d4		; no extension
	lea	which_file,a0
	lea	fname_sp(a4),a1
	move.l	a1,a2
	move.l	#-1,a3
	jsr	do_fsel
	tst.l	d0
	bgt	startreq
	beq.s	ok_file
	bra	act_esc
ok_file move.l	#512,step(a4)
	move.w	#512,seclen(a4)
	move.l	#0,endsek(a4)
	move.l	#0,sector(a4)
	move.l	a1,a0
opfile	moveq	#-$01,d1
	moveq	#0,d3
	moveq	#1,d0
	trap	#2		; open file
	tst.l	d0		; ok?
	beq.s	no_prob 	; yes ->...
	xref	driv
	lea	driv,a0
	bsr	read_error
	bra.s	do_file
no_prob move.l	a0,file_id(a4)	; file opened ok: channel id
	move.w	d0,row(a4)	; first row (d0 = 0)
	lea	file_sp(a4),a1
	moveq	#64,d2
	moveq	#-1,d3
	moveq	#$47,d0
	trap	#3		; read file header
	tst.l	d0
	bne.s	no_luck
	lea	file_sp(a4),a1
	move.l	(a1),d1 	; get length of file
	move.l	d1,d2
	andi.w	#$fe00,d1	; make last block possible
	cmp.l	d1,d2		; special case if file is an exact...
	bne.s	store
	sub.l	#$200,d1	; ...  nbr of 512 bytes long
store	move.l	d1,endsek(a4)	; store
	bsr	read_sec	; try to read a sector from it
	bne.s	no_luck 	; if error: show it ->...
	jsr	rdrwinfo
	bra	op_out
no_luck move.l	d0,-(a7)
	move.l	file_id(a4),a0
	moveq	#2,d0
	trap	#2		; close file
	move.l	(a7)+,d0
	bra	file_edit




	end
