; options set for WINED
; this sets the floppy options within the program
; this is the status menu, called from the main window
;
; v. 1.03	2016 Jul 04 08:37:28  use keys on dev8_ (smsqe keys)
; v. 1.02	1994 Dec 11 11:55:16
;  W. Lenerz 1994 - 2018

		section options

	include dev1_asm_wined_includes
	include dev8_keys_wstatus
	include dev8_keys_wman
	include dev8_keys_wwork
	include dev8_keys_wdef

		xdef	act_opts
		xdef	act_opts2
		xdef	opact_dd
		xdef	opact_hd
						  
		xdef	opact_sd
		xdef	opact_tr
		xdef	flp_parms

		xref	optsdef
		xref	redraw	; redraws items & returns from
				; item action routine (wined_itact)

		xref	set_drive

myregs	reg	d4-d7/a0-a4/a6

con	dc.w	3,'CON'

act_opts
	move.b	#1,$40+it_opts(a1)	; reset item to available
act_opts2
	movem.l myregs,-(a7)
	lea	btnstat(a4),a1	;
	lea	btn(a4),a4	; point to working defn for button
	lea	optsdef,a3	; this is the window definition
	moveq	#0,d1
	jsr	4(a5)		; set up this window
;
;	 move.b  #$10,$42(a1)	 ; set ed to unavailable
;
	moveq	#-1,d1
	jsr	$10(a5) 	; pull down
	jsr	wm.wdraw(a5)	; draw
rd	jsr	wm.rptr(a5)	; read pointer until click
	tst.l	d0
	beq.s	rd
out	jsr	wm.unset(a5)
	moveq	#2,d0
	trap	#2
	movem.l (a7)+,myregs
	bsr.s	flp_parms
	moveq	#0,d0
	jmp	redraw

; this sets the actual floppy disk params in our memory area
flp_parms cmp.w #flodisk,type(a4)	; are we editing floppy disks?
	beq.s	do_parms		; yes
	rts			; no, so just return
do_parms	move.l	a1,-(a7)
	lea	btnstat+$40(a4),a1
	tst.b	2(a1)		; is ed set?
	bmi.s	is_ed		; yes->...
	tst.b	3(a1)		; is hd set?
	bmi.s	is_hd		; yes ->...
is_dd	move.w	#9,maxsect(a4)	; if not hd or ed, it must be dd
	move.w	#0,ftype(a4)
	move.w	#512,seclen(a4)
	bra.s	sides

is_hd	move.w	#18,maxsect(a4)
	move.w	#1,ftype(a4)
	move.w	#512,seclen(a4)
	bra.s	sides

is_ed	move.w	#10,maxsect(a4)
	move.w	#2,ftype(a4)
	move.w	#2048,seclen(a4)

sides	tst.b	5(a1)		; is it one side only?
	beq.s	is_sid2 	; no->...
is_sid1 move.w	#0,maxsides(a4)
	bra.s	tracks
is_sid2 move.w	#1,maxsides(a4)

tracks	tst.b	7(a1)		; is it 40 tracks?
	beq.s	is_trk8 	; no->...
is_trk4 move.w	#39,maxtrack(a4)	; new tracks number
	bra.s	opts_out
is_trk8 move.w	#79,maxtrack(a4)	; new tracks number

opts_out	bsr	set_drive
	move.l	(a7)+,a1
	rts

; options menu item routines

opact_hd
	move.b	#1,$45(a1)	; 1 side to available
	move.b	#1,$47(a1)	; 40 tracks to available
	move.b	#$81,$46(a1)	; 2 sides selected
	move.b	#$81,$48(a1)	; 80 tracks selected
		
opact_dd
	lea	$43(a1),a2
	move.b	#$1,$42(a1)
	bra.s	opact_com

opact_tr
	lea	$47(a1),a2
	bra.s	opact_com
opact_sd
	lea	$45(a1),a2
opact_com
	move.w	wwl_item(a3),d0
	move.b	#1,(a2) 	; set the two items to available
	move.b	#1,1(a2)		;
	move.b	#$81,$40(a1,d0.w)	; set item clicked to selected

;	 move.b  #$10,$42(a1)	 ; set ed to unavailable

	moveq	#0,d0
	jmp	redraw
	end
