; window definition for wined
; v. 1.04	2003 jan 07 17:02:02
;  W. Lenerz 1994 - 2018

	section wdef

	include dev1_asm_wined_includes
	include dev1_asm_incl_keys_k
	include dev1_asm_incl_keys_wman_vectors
	include dev1_asm_incl_keys_syspal

	xdef	windef
	xdef	hrep
	xdef	appl1
; sprites
	xref	cross		; pointer sprite
	xref	move_sprt
	xref	zzz_sprt
	xref	wake_sprt
	xref	sp_cursor
	xref	size_sprt
	xref	options_sprt
	xref	f6_sprt
; sprite pointers
	xdef	sp_mve
	xdef	sp_sze
	xdef	sp_wke
	xdef	sp_slp
	xdef	sp_f6
; item action routines
	xref	act_esc
	xref	act_move
	xref	act_zzz
	xref	act_wake
	xref	act_size
;	 xref	 act_f1
	xref	act_f2
	xref	act_f3
	xref	act_f4
	xref	act_sec
	xref	act_drv
	xref	act_about	; in about_asm
	xref	act_off
	xref	act_opts
	xref	act_1
; strings
	xref	tit_str
	xref.s	titwinxs
	xref.s	temp4
	xref	about_txt
;	 xref	 second
	xref	f2_men
	xref	f3_men
	xref	f4_men
	xref	nbr_sects
	xref	driv
	xref	off_txt 	; string with offset number
	xref	vsmal_cha
	xref	long_cha


; selection keys
	xref.s	k.drive 	; drive item selection key
	xref.s	k.about

; application subwindow routines
	xref	draw_app		; application sub window draw routine
	xref	app_hit 	; hit routine


; these remain normally unchanged
lxs	equ	24
lys	equ	12
rays	equ	14

lxs2	equ	100
lxs3	equ	108
xof	equ	16
apof	equ	36
; change these to suit size


ysize	equ	216		; y size of window
nbrits	equ	4		; max nbr of items in one corner
mbarxorg  equ  nbrits*lxs+6    ; x orig of menu bar

obof	equ	8
bof2	equ	obof+14
rang	equ	20

; these are used for calculations

temp2	equ	mbarxorg*2
mbarlen equ	xsize-temp2-12	 ; rem length of menu bar

windef	dc.w	xsize		; default window x size
	dc.w	ysize		;	      y size
	dc.w	lys		 ;initial pointer x position
	dc.w	20		;	       y position
	dc.b	$00		; msbit clear to clear window
	dc.b	2		; shadow depth
	dc.w	1		; border width
	dc.w	sp.winbd	;border colour
	dc.w	sp.winbg	;paper colour

	dc.w	cross-* 	; pointer to pointer sprite

; menu item attributes
	dc.w	1		;current item border width
	dc.w	sp.litemhigh	;	    border colour

; menu item unavailable:
	dc.w	sp.litemunabg	;background colour
	dc.w	sp.litemunafg	;text object ink colour
	dc.w	0		;pointer to blob for pattern
	dc.w	0		;pointer to pattern for blob
; menu item available  :
	dc.w	sp.litemavabg	;background colour
	dc.w	sp.litemavafg	;text object ink colour
	dc.w	0		;pointer to blob for pattern
	dc.w	0		;pointer to pattern for blob
; menu item selected   :
	dc.w	sp.litemselbg	;background colou
	dc.w	sp.litemselfg	;text object ink colour
	dc.w	0		;pointer to blob for pattern
	dc.w	0		;pointer to pattern for blob


; possible help window
	dc.w	0		; pointer to help window
;base of repeated part of window definition
hrep	dc.w	xsize		; x (min.) size for this layout
	dc.w	ysize		; y (min.) size for this layout
;pointers to definition lists :
	dc.w	info-*		; information sub-windows
	dc.w	loose-* 	; loose items
	dc.w	appl-*		; application sub-windows
;
	dc.w	-1		; end flag
;



;information sub-window definition list :
;========================================

;
;information sub-window no. 0  (menue leiste)
info	dc.w	mbarlen 	; sub-window x size
	dc.w	rays		; sub-window y size
	dc.w	mbarxorg		; sub-window x origin
	dc.w	0		; sub-window y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	sp.infwinbd	;border colour
	dc.w	sp.titlebg	;paper colour
	dc.w	0		; pointer to information object list

;information sub-window no. 1 (with section number and items)
	dc.w	xsize-8 	; sub-window x size
	dc.w	apof-2		; sub-window y size
	dc.w	4		; sub-window x origin
	dc.w	16		; sub-window y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	1		; border width

	dc.w	sp.infwinbd	;border colour
	dc.w	sp.infwinbg	;paper colour

	dc.w	sect_ob-*	; pointer to information object list

; info window 2 (with title)
	dc.w	titwinxs		; hit area  x size
	dc.w	11		;	  y size
	dc.w	temp4		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	sp.infwinbd	;border colour
	dc.w	sp.titletextbg	;paper colour
	dc.w	title_obj-*	; pointer to information object list

	dc.w	12		; hit area  x size
	dc.w	rays		;	  y size
	dc.w	mbarlen+mbarxorg	;	  x origin
	dc.w	0		;	  y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	sp.infwinbd	;border colour
	dc.w	sp.infwinbg	;paper colour

	dc.w	f6_obj-*		; pointer to information object list

	dc.w	-1
	xdef	sect_ob
sect_ob dc.w	lxs3		; object x size
	dc.w	10		;	y size
	dc.w	4		;	x origin
	dc.w	rang		;	y origin
	dc.b	text-1		; object type
	dc.b	0		; spare
	dc.w	sp.infwinfg		  ; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	driv-*		; pointer to object


	dc.w	lxs3		; object x size
	dc.w	10		;	y size
	dc.w	xof-4+lxs3*3	  ;	x origin
	dc.w	rang		;	y origin
	dc.b	text-1		; object type
	dc.b	0		; spare
	dc.w	sp.infwinfg		  ; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	ofset-* 	; pointer to object
	dc.w	-1

f6_obj	dc.w	10		 ; object x size
	dc.w	rays-2		    ;	  y size
	dc.w	2
	dc.w	4	      ;     y origin
	dc.b	sprite		; object type
	dc.b	0		; spare
	dc.w	0		; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
sp_f6	dc.w	f6_sprt-*	  ; pointer to object
	dc.w	-1

ofset	dc.w	of-*-2
	dc.b	'Off:'
of

title_obj dc.w	100		; object x size
	dc.w	10		;	y size
	dc.w	2		;	x origin
	dc.w	1		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	sp.titlefg	; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	tit_str-*	; pointer to object

	dc.w  -1


;loose menu item definition list :
;========================================


loose	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	4		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	k.cancel		; selection keystroke
	dc.w	ob_esc-*		; pointer to object
	dc.w	it_esc		; item number
	dc.w	act_esc-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	lxs+6		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.move		; selection keystroke
sp_mve	dc.w	move_sprt-*	; pointer to object
	dc.w	it_move 	; item number
	dc.w	act_move-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xsize-lxs-4	;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.sleep 	; selection keystroke
sp_slp	dc.w	zzz_sprt-*	; pointer to object
	dc.w	it_zzz		; item number
	dc.w	act_zzz-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xsize-4-lxs*2	;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.wake		; selection keystroke
sp_wke	dc.w	wake_sprt-*	; pointer to object
	dc.w	it_wake 	; item number
	dc.w	act_wake-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xsize-4-lxs*3	;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.size		; selection keystroke
sp_sze	dc.w	size_sprt-*	; pointer to object
	dc.w	it_size 	; item number
	dc.w	act_size-*	; pointer to action routine

; why is this here?
	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	xof-8		;	  x origin
	dc.w	rang		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	k.help		; selection keystroke
	dc.w	0		; pointer to object
	dc.w	it_f1		; item number
	dc.w	0
;	 dc.w	 act_f1-*	 ; pointer to action routine

	dc.w	lxs2		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xof+lxs3		;	  x origin
	dc.w	rang		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	f2		; selection keystroke
	dc.w	f2_men-*		; pointer to object
	dc.w	it_f2		; item number
	dc.w	act_f2-*		; pointer to action routine

	dc.w	lxs2		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xof+lxs3*2	;	  x origin
	dc.w	rang		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	f3		; selection keystroke
	dc.w	f3_men-*		; pointer to object
	dc.w	it_f3		; item number
	dc.w	act_f3-*		; pointer to action routine

	dc.w	lxs2-8		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xof+lxs3*3	;	  x origin
	dc.w	rang		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	f4		; selection keystroke
	dc.w	f4_men-*		; pointer to object
	dc.w	it_f4		; item number
	dc.w	act_f4-*		; pointer to action routine

	dc.w	204		; hit area   x size
	dc.w	lys-2		;	  y size
	dc.w	xof+lxs3		;	  x origin
	dc.w	rang+16 	;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	f5		; selection keystroke
	dc.w	0		; pointer to object
	dc.w	it_sec		; item number
	dc.w	act_sec-*	; pointer to action routine

	dc.w	36		; hit area   x size
	dc.w	lys-2		;	  y size
	dc.w	xof+40		;	  x origin
	dc.w	rang+16 	;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	k.drive 	; selection keystroke
	dc.w	0		; pointer to object
	dc.w	it_drv		; item number
	dc.w	act_drv-*	; pointer to action routine

	dc.w	lxs+8		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	lxs*2+10		 ;	   x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	k.about 	; selection keystroke
	dc.w	about_txt-*	; pointer to object
	dc.w	it_about		; item number
	dc.w	act_about-*	; pointer to action routine


	dc.w	42		; hit area   x size
	dc.w	lys-2		;	  y size
	dc.w	xof+40+lxs3*3	;	  x origin
	dc.w	rang+16 	;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'o'		; selection keystroke
	dc.w	off_txt-*	; pointer to object
	dc.w	it_off		; item number
	dc.w	act_off-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xsize-4-lxs*4	;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.f6		; selection keystroke
	dc.w	options_sprt-*	; pointer to object
	dc.w	it_opts 	; item number
	dc.w	act_opts-*	; pointer to action routine

	dc.w	lxs2		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xof-8		;	  x origin
	dc.w	rang		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'1'		; selection keystroke
	dc.w	long_cha-*
	dc.w	it_1		 ; item number
	dc.w	act_1-* 	 ; pointer to action routine

	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'2'		; selection keystroke
	dc.w	0
	dc.w	it_2		; item number
	dc.w	act_1-* 	; pointer to action routine

	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'3'		; selection keystroke
	dc.w	0
	dc.w	it_3		; item number
	dc.w	act_1-* 	; pointer to action routine

	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'4'		; selection keystroke
	dc.w	0
	dc.w	it_4		; item number
	dc.w	act_1-* 	; pointer to action routine

	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'5'		; selection keystroke
	dc.w	0
	dc.w	it_5		; item number
	dc.w	act_1-* 	; pointer to action routine

	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'6'		; selection keystroke
	dc.w	0
	dc.w	it_6		; item number
	dc.w	act_1-* 	; pointer to action routine
		    
	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'7'		; selection keystroke
	dc.w	0
	dc.w	it_7		; item number
	dc.w	act_1-* 	; pointer to action routine
		    
	dc.w	0		; hit area   x size
	dc.w	0		;	  y size
	dc.w	0		;	  x origin
	dc.w	0		;	  y origin
	dc.b	1		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'8'		; selection keystroke
	dc.w	0
	dc.w	it_8		; item number
	dc.w	act_1-* 	; pointer to action routine

	dc.w	-1

ob_esc	dc.w	3,'ESC'



appl	dc.w	appl1-*,0
app1yoff equ	 14
	dc.b	3,3
	DC.L	'XTND'
appl1	dc.w	xsize-8 	; sub-window x size
	dc.w	ysize-rays-apof-4	; sub-window y size
	dc.l	app_origs

	dc.b	$00		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	1		; border width
	dc.w	sp.winbd	;border colour
	dc.w	sp.winbg	;paper colour
	dc.w	sp_cursor-*	; pointer to pointer sprite
	dc.w	0		; no setup
	dc.w	draw_app-*	; draw
	dc.w	app_hit-*	; hit
	dc.w	0		; no ctrl
	dc.w	0,0 fw		  ; no x,y sections
	dc.b	253,0
	dc.w	-1


; typical window


; ------------------------------------------------------------------------
; options definition
      
	xdef	optsdef

	xref	opact_dd
	xref	opact_hd
						  
	xref	opact_sd
	xref	opact_tr
	xref	floppy_type
	xref	tracknbr
	xref	sidesnbr

; change these to suit size
optitlen	equ	6		; number of chars in title
optsxsiz	equ	142		; x size of window (should be / 4)
optsysiz	equ	156		; y size of window
optsits  equ	1		; max nbr of items in one corner
optsmbar	equ	optsits*lxs+2	 ; x orig of menu bar

; these are used for calculations

temp5	equ	optsmbar*2
ombarlen	equ	optsxsiz-temp5-4	   ; rem length of menu bar
optstitx	equ	optitlen*6+4
temp6	equ	optsxsiz-optstitx
temp7	equ	temp6/2

xofs	equ	16
xxo	equ	24


optsdef dc.w	optsxsiz		   ; default window x size
	dc.w	optsysiz		   ;		 y size
	dc.w	120		 ;initial pointer x position
	dc.w	20		;	       y position
	dc.b	$00		; msbit clear to clear window
	dc.b	2		; shadow depth
	dc.w	1		; border width
	
	dc.w	sp.winbd	;border colour
	dc.w	sp.winbg	;paper colour

	dc.w	cross-* 	; pointer to pointer sprite

; menu item attributes
	dc.w	1		;current item border width
	dc.w	sp.litemhigh	;	    border colour

; menu item unavailable:
	dc.w	sp.litemunabg	;background colour
	dc.w	sp.litemunafg	;text object ink colour
	dc.w	0		;pointer to blob for pattern
	dc.w	0		;pointer to pattern for blob
; menu item available  :
	dc.w	sp.litemavabg	;background colour
	dc.w	sp.litemavafg	;text object ink colour
	dc.w	0		;pointer to blob for pattern
	dc.w	0		;pointer to pattern for blob
; menu item selected   :
	dc.w	sp.litemselbg	;background colou
	dc.w	sp.litemselfg	;text object ink colour
	dc.w	0		;pointer to blob for pattern
	dc.w	0		;pointer to pattern for blob
		


; possible help window
	dc.w	0		; pointer to help window
;base of repeated part of window definition
	dc.w	optsxsiz		   ; x (min.) size for this layout
	dc.w	optsysiz		   ; y (min.) size for this layout
;pointers to definition lists :

	dc.w	opinfo-*		  ; information sub-windows
	dc.w	oploose-*	  ; loose items
	dc.w	0		; application sub-windows
;
	dc.w	-1		; end flag
;



;information sub-window definition list :
;========================================

;
;information sub-window no. 0  (menue leiste)
opinfo	dc.w	ombarlen		 ; sub-window x size
	dc.w	rays		; sub-window y size
	dc.w	optsmbar		; sub-window x origin
	dc.w	0		; sub-window y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	sp.infwinbd	;border colour
	dc.w	sp.titlebg	;paper colour
	dc.w	0		; pointer to information object list


;information sub-window no. 2 (big info subwindow)
	dc.w	optsxsiz-8	   ; sub-window x size
	dc.w	optsysiz-rays-4    ; sub-window y size
	dc.w	4		; sub-window x origin
	dc.w	rays+2		; sub-window y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	1		; border width
	dc.w	sp.infwinbd	;border colour
	dc.w	sp.infwinbg	;paper colour
	dc.w	choices-*	 ; pointer to information object list


; info window 2 (with title)
	dc.w	optstitx		; hit area  x size
	dc.w	11		;	  y size
	dc.w	temp7		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; msbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	sp.infwinbd	;border colour
	dc.w	sp.titletextbg	   ;paper colour
	dc.w	itle_obj-*	   ; pointer to information object list

	dc.w	-1

itle_obj	dc.w	100		; object x size
	dc.w	10		;	y size
	dc.w	2		;	x origin
	dc.w	1		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	sp.titlefg	; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	optit_str-*	   ; pointer to object

	dc.w  -1


optit_str dc.w	optitlen
	dc.w	'option'

choices dc.w	100		; object x size
	dc.w	10		;	y size
	dc.w	2		;	x origin
	dc.w	xxo-16		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	sp.infwinfg		  ; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	floppy_type-*	; pointer to object

	dc.w	100		; object x size
	dc.w	10		;	y size
	dc.w	2		;	x origin
	dc.w	xofs*4		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	sp.infwinfg		  ; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	sidesnbr-*	; pointer to object

	dc.w	100		; object x size
	dc.w	10		;	y size
	dc.w	2		;	x origin
	dc.w	xofs*6+8		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	sp.infwinfg		  ; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	tracknbr-*	; pointer to object
					
	dc.w  -1



;loose menu item definition list :
;========================================

oploose dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	4		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	k.cancel		; selection keystroke
	dc.w	ob_esc-*		; pointer to object
	dc.w	0		; item number
	dc.w	opact_esc-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-lxs-4	   ;	     x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'o'		; selection keystroke
	dc.w	ob_ok-* 	; pointer to object
	dc.w	1		; item number
	dc.w	opact_do-*	; pointer to action routine


	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	xxo		  ;	    y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'e'		; selection keystroke
	dc.w	ob_ed-* 	; pointer to object
	dc.w	2		; item number
	dc.w	opact_hd-*	; pointer to action routine
 
	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	xxo+xofs		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'h'		; selection keystroke
	dc.w	ob_hd-* 	; pointer to object
	dc.w	3		; item number
	dc.w	opact_hd-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	xofs*2+xxo	;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'd'		; selection keystroke
	dc.w	ob_dd-* 	; pointer to object
	dc.w	4		; item number
	dc.w	opact_dd-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	xofs*3+xxo+8	;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-2		; object type
	dc.b	'1'		; selection keystroke
	dc.w	ob_01-* 	; pointer to object
	dc.w	5		; item number
	dc.w	opact_sd-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	xofs*4+xxo+8	;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-2		; object type
	dc.b	'2'		; selection keystroke
	dc.w	ob_02-* 	; pointer to object
	dc.w	6		; item number
	dc.w	opact_sd-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	120		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'4'		; selection keystroke
	dc.w	ob_40-* 	; pointer to object
	dc.w	7		; item number
	dc.w	opact_tr-*	; pointer to action routine

	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	optsxsiz-30	;	  x origin
	dc.w	xofs*6+xxo+16	 ;	   y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text-1		; object type
	dc.b	'8'		; selection keystroke
	dc.w	ob_80-* 	; pointer to object
	dc.w	8		; item number
	dc.w	opact_tr-*	; pointer to action routine
 
	dc.w	-1

ob_ok	dc.w	2,'OK'
ob_ed	dc.w	2,'ED'
ob_hd	dc.w	2,'HD'
ob_dd	dc.w	2,'DD'
ob_01	dc.w	2,' 1'
ob_02	dc.w	2,' 2'
ob_40	dc.w	2,'40'
ob_80	dc.w	2,'80'



opact_esc
	move.b	#1,$40(a1)
	moveq	#-1,d0
	rts

opact_do
	move.b	#1,$41(a1)
	moveq	#-2,d0
	rts

	xdef copy
copy	dc.w	copy2-*-2
	dc.b	' Copyright  1994-2016',$a,' Wolfgang Lenerz'
copy2
	dc.w	0
	end
